	SECTION	QXL

	include	dev1_asm_incl_keys_err

	xref	rt_fp

	xdef	rel_out
	xdef	errbp
	xdef	unlink
	xdef	unlink2
	xdef	swap_byte
	xdef	fat_error

; v. 1.03 new code (in basic2_asm) for winx_*d2d files
; v. 1.02 code copes with intel byte format (reversed byte order in word)
; v. 1.01 code made re-entrant & rommable
**************************************************************************************
; some macros
; macro to define sbasic keywords where name & name of routine are the same

kwrd	macro	name
	dc.w	[name]-*
	dc.b	[.len(name)]
	dc.b	'[name]'
	endm

XJSR	macro	name
	xref	[name]		; - makes external jump
	JSR	[name]
	ENDM
************************************************************************************

; start of code - jst link in Sbasic fns
start	LEA	procs,A1
	MOVE.W	$110,A2
	JMP	(A2)

; sbasic procedures
	xref	qxl_fat2
	xref	qxl_rfile2
	xref	qxl_offset2

procs	DC.W	0,0,7
	kwrd	QXL_FAT
	kwrd	QXL_RFILE
	kwrd	QXL_OFFSET
	kwrd	QXL_FAT2
	kwrd	QXL_RFILE2
	kwrd	QXL_OFFSET2
	DC.L	0,0

sec_len	EQU	2048		; here we have 2048 byte "sectors"

***************************************************************************
*
*	offset=QXL_OFFSET #chan%[,start]
*
*
* this tries to find a QXLWIN file in $100 "sectors" of the cdr
*
* it returns the offset (i.e. nbr of bytes from start), or:
*
* -1 no offet found in 256 sectors
* -2 problem when getting data from file
* if the offset is negative, then it is an intel partition

*
***************************************************************************


qxl_offset MOVEQ	#0,D7
	XJSR	chan_num		; get channel ID
	BNE	rel_out		  ; oops
	MOVE.L	A0,A4
	CMP.L	A5,A3		; any more params?
	BEQ.S	no_param
	MOVE.W	$118,A2
	JSR	(A2)
	TST.L	D0
	BNE.S	rel_out
	ADDQ.L	#4,$58(A6)
	MOVE.L	(A6,A1.L),D7	; start
no_param	MOVE.L	#sec_len,D0
	XJSR	gu_achp		; get memory for 1 sector
	BNE.S	rel_out
	EXG	A0,A4
	MOVEQ	#-1,D3
	MOVE.L	#sec_len,D2	; nbr of bytes to get each time
	MOVE.L	D7,D6
	ADD.L	#$101*sec_len,D7	; point $101 "sectors" further on
loop	MOVE.L	A4,A1		; this is where we read
	MOVE.L	D6,D1
	MOVEQ	#$42,D0
	TRAP	#3		; (re)position file
	TST.L	D0		; ok?
	BNE.S	no_off2		; no, so pretend no offset found->...
lo2	MOVEQ	#3,D0		; now get sec_len bytes
	TRAP	#3
	TST.L	D0		; ok?
	BEQ.S	got		; yes->...
	CMP.L	#-1,D0		; no, test whether error = incomplete
	BNE.S	no_off2		; no, so big problem - leave->...
	BRA.S	loop		; yes, try again->...

; ! danger of infinite loop here !

got	CMP.L	#'QLWA',(A4)	; is this the QXL Win file?
	BEQ.S	found_it		; yes!->...
	CMP.L	#'LQAW',(A4)	; is it a swapped QXL WIN file?
	BNE.S	no_swap		; no->...
	NEG.L	D6		; yes so show it
	BRA.S	found_it
no_swap	ADD.L	#2048,D6		; point next sector
	CMP.L	D6,D7		; reach the end of these sectors?
	BNE.S	loop		; not yet->...
no_off	MOVEQ	#-1,D6		; show no offset found!
found_it	MOVE.L	A4,A0
	XJSR	gu_rchp		; release mem
	MOVE.L	D6,D2		; return number as float
	JMP	rt_fp
no_off2	MOVEQ	#-2,D6		; end of file!
	BRA.S	found_it
	       

**************************************************************************************
*
* QXL_FAT :  fat = QXL_FAT (#chan%,offset,swap)
*
*
* this reads in the entire (!) FAT for the qxl drive
*
* chan% is the channel opened to the cdr drive: cdrx_*d8d
***************************************************************


errbp	MOVEQ	#-15,d0
rel_out	RTS
qxl_fat
	XJSR	chan_num2 	; get channel ID into A4
	BNE	rel_out		; oops
	MOVE.W	$118,A2
	JSR	(A2)
	BNE.S	rel_out
	SUBQ.W	#2,D3		; there must have been 2 params
	BNE.S	errbp		; but there weren't
	MOVE.L	(A6,A1.L),D7	; D7 = offset (in bytes)
	MOVE.L	4(A6,A1.L),D6	; D6 = swap indicator
	ADDQ.L	#8,$58(A6)	; reset math stack
	MOVE.L	#sec_len,D0
	XJSR	gu_achp		; get some mem now
	BNE.S	rel_out		; ooops
	EXG	A0,A4		; A4 = mem, A0 = channel ID
test	MOVE.L	D7,D1		; start of QXL file
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	TST.L	D0
	BNE	unlink2		; oops->....
	MOVE.L	#512,D2		; get 512 bytes
	MOVE.L	A4,A1		; into here...
	MOVEQ	#3,D0
	TRAP	#3		; now...
	TST.L	D0		; ok?
	BNE	unlink2		; oops->...
	CLR.L	D5
;	 MOVE.W	 $22(A4),D5	 ; number of sectors per cluster in QLD
;	 TST.W	 D6		 ; is byte order swapped?
;	 BEQ.S	 noswap1		 ; no ->...
;	 ROL.W	 #8,D5		 ; yes, so swap as well
;noswap1	 MULU	 #512,D5		 ; number of bytes per cluster
	MOVE.W	$2A(A4),D0	; number of clusters in fat
	TST.W	D6		; swap byte order?
	BEQ.S	noswap2		; no->...
	ROL.W	#8,D0		; yes!
noswap2	LSL.L	#1,D0		; fat = 2 bytes per cluster
	ADD.L	#$144,D0		; total number of bytes needed ($40...
	MOVE.L	D0,D2		; ... for header + 4 bytes for RECHP...
;	 ADD.L	 D5,D0		 ;  ... link +$100 buffer)
	ADD.L	#2048,D0
	EXG	A4,A0		; A4 = channel ID, A0 = memory
	XJSR	gu_rchp		; release OLD memory
	XJSR	gu_achp		; and get my memory
	BNE.S	qxl_err		; oops ->...
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into heap
	ADDQ.L	#4,A0		; cut out linkage area, for RECHP
	EXG	A4,A0		; A0 = channel ID, A4 = memory
rdlp	MOVE.L	D7,D1
	MOVEQ	#$42,D0
	TRAP	#3		; reposition at beginning of file
	TST.L	D0		; ok?
	BNE	unlink2		; no->....!
	MOVE.L	A4,A1		; pointer to space for header & FAT
	MOVE.L	D2,D4		; nbr of bytes to get
; try to get as much data from the file as possible in one go
; (remember, D2 contains nbr of bytes to get in a WORD)
do_loop	CMP.L	#$8000,D4 	;
	BLE.S	end
	SUB.L	#$7FFE,D4
	MOVE.L	#$7FFE,D2
iloop	MOVEQ	#3,D0
	TRAP	#3		; get D2	bytes
	TST.L	D0		; ok?
	BEQ.S	do_loop		; yes, go around again->...
	BRA	unlink2		 ; no, quit!->...
end	MOVE.L	D4,D2
	MOVEQ	#3,D0
	TRAP	#3
	TST.L	D0
	BNE	unlink2
	TST.W	D6
	BEQ.S	noswap3		; no->...
	MOVE.L	A4,A0		; start of mem
	BSR.S	swap_byte 	; swap bytes now....

noswap3	MOVE.L	D7,(A4)		; my offset at beginning of fat!!!
	MOVE.L	A4,D2
	JMP	rt_fp		; return address now

qxl_err	RTS
qxl_err2	MOVEQ	#-15,D0
qxl_err1	MOVE.L	A4,A0
	XJSR	gu_rchp
	RTS


************************************************
*	swap_byte
* swaps byte in a word in the entire file
*
* A0 = start of file
* A3 = end of file
************************************************
swap_byte MOVE.W	(A0),D0		; get one word
	ROL.W	#8,D0		; swap byte order
	MOVE.W	D0,(A0)+		; and put it back
	CMP.L	A0,A3		; end reached?
	BGE.S	swap_byte 	; no, go around again ->...
	RTS			; yes, finished


*****************************************************************
*
*
*        file = QXL_RFILE (#channel%, swap,fat,initial cluster,length_of_file)
*
*        read an entire file into memory !
*
*	file= address of file in memory, or 0 if error
*
*
*****************************************************************


qxl_rfile
	XJSR	chan_num2 	; get channel ID into A4
	MOVE.W	$118,A2
	JSR	(A2)		; get long ints
	TST.L	D0
	BNE.S	qxl_err		; oops->...
	SUBQ.W	#4,D3		; there MUST be 4 ints
	BNE	errbp		; but there weren't
	ADD.L	#16,$58(A6)
	MOVE.L	(A6,A1.L),D4	; swap flag
	MOVE.L	4(A6,A1.L),A5	; fat pointer
	MOVE.L	8(A6,A1.L),D6	; initial cluster
	MOVE.L	12(A6,A1.L),D7	; length of this file (incl. header)
	MOVE.L	D7,D0
	CLR.L	D5
	MOVE.W	$22(A5),D5	; number of sectors per cluster in QLD
	MULU	#512,D5		; number of bytes per cluster
	ADD.L	d5,D0		; just to be on the safe side
	ADDQ.L	#1,D0
	BCLR	#0,D0		; and make sure it's even
	XJSR	gu_achp		; get mem now
	BNE	rel_out		; oops! ->...
	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into heap
	ADDQ.L	#4,A0		; cut out linkage area (for RECHP)
	EXG	A0,A4		; A4 = MEM PTR, A0 = CHANNEL ID
	MOVE.L	A4,A1		; point to space for file
	MOVE.L	A4,A3
	ADD.L	D7,A3		; point to end of file
readloop	BSR.S	readclust 	; read cluster into (A1) now
	BNE.S	unlink2		; ooops
	TST.W	D6		; any more clusters to get?
	BEQ.S	rf_end		; no, finished->...
	CMP.L	#-1,D6		;
	BEQ.S	fat_error 	; this * should * never happen
	AND.L	#$FFFF,D1
	SUB.L	D1,D7
	BGT.S	readloop		; don't get more than file length, anyway!
rf_end	TST.L	D4		; deal with intel crap?
	BEQ.S	rf_end2		; no ->...
	MOVE.L	A4,A0		; point to memory
	BSR	swap_byte 	; swap everything

rf_end2	MOVE.L	A4,D2		; return memory
	JMP	rt_fp

; there was an error in the fat - it happens!
fat_error BSR.S	unlink2
	CLR.L	D2		; return 0
	JMP	rt_fp		;

**********************************************************
;
; readclust subroutine
; read the wished QXL cluster

; some assumptions:
; a "qxl" cluster is the cluster ("allocation unit") used by the QXL.WIN file
;
; a 'cdr' doesn't really have clusters, just sectors
;
; a "qxl" cluster is made up of x sectors of 512 bytes.

; to read a "qxl" cluster, you do the following:
;  0  position cdr to start of cluster (QXL cluster nbr * nbr of bytes in
;     a cluster + possible offset)
;  1  D2 = nbr of bytes in 1 qxl cluster
;  2  read 2048 bytes from CDROM
;  3  if got: 4, else 2
;  4  deduct 2048 from D2
;  5  if 0 or less: 6, else 2
;  6  finished

rcregs	REG	D2-D4/A2

; this reads one QLD cluster into the memory pointed to by A1
; on entry			exit
;
; A0 = CDROM channel ID		stet
; A1 = memory for lcuster		updated
; A5 = FAT			stet
; D1 = ????			nbr of bytes got
; D5 = nbr of bytes per QXL cluster
; always a multiple of 512 bytes
; D6.L = cluster to be read		NEXT corresponding cluster (or 0)
;
; the cdrx_d8d file needs to have the file positon in BYTES; not
; 2048 sector numbers, which is quite handy
readclust MOVEM.L	rcregs,-(A7)
	MOVE.L	D5,D1		; number of bytes per QXL cluster
	MOVE.L	D1,D2		; we need to read that much
	MULU	D6,D1		; cl. nbr * bytes per clust= clust position in QXL file
	ADD.L	(A5),D1		; offset to start of QXL file
	MOVEQ	#-1,D3
	MOVEQ	#$42,D0
	TRAP	#3		; reposition here
	TST.L	D0		; ok?
	BNE.S	rc_out		; what?
lo	MOVEQ	#3,D0		; now get D2 bytes
	TRAP	#3
	TST.L	D0		; ok?
;	 BEQ.S	 getnentry	 ; yes->...
;	 CMP.L	 #-1,D0		 ; no, was call incomplete?
	BNE.S	rc_out		; no, another error->...
;	 SUB.W	 D1,D2		 ; incomplete, do again->...
;	 BRA.S	 lo
; now calculate the next fat cluster
getnentry ADD.L	D6,D6		; FAT entry  = 1 word
	ADD.L	#$40,D6		; + fat header offset
	MOVE.W	(A5,D6.L),D0	; new FAT entry for this file
	MOVE.L	D0,D6		; make sure upper word is 0
	MOVEQ	#0,D0		;
rc_out	MOVEM.L	(A7)+,rcregs
p_out	RTS
   


**********************************************************************
*
* this unlinks my memory from the Sbasic linked rechp list
*
* IT IS AN ERROR RETURN
; onentry A0 = memptr, after link
*
**********************************************************************

unlink2	MOVE.L	A4,A0		; point to mem
unlink	SUBQ.L	#4,A0		; get link back
	MOVE.L	$E0(A6),A1	; lined list
unlnk_lp	MOVE.L	(A1),D1		; now find my entry
	BEQ	errbp		; what, no more?
	CMP.L	A0,D1
	BEQ.S	do_unlink
	MOVE.L	D1,A1
	BRA.S	unlnk_lp
do_unlink MOVE.L	(A0),(A1)
	MOVE.L	D0,D6
	MOVEQ	#$19,D0
	TRAP	#1
	MOVE.L	D6,D0
	RTS
	


	end



difference between cdrx_*d8d (and normal) files and winx_*d2d files:

1 - in winx_*d2d file, the file position is given as 512 bytes sector
2 - in winx_*d2d file, reading one sector DOES NOT increase the file pos ptr,
    so you must set the file pos ptr explicitly before every call.
3 - you can't get more than 512 bytes from one read call.
